/**
 *  File Name  = axCmdLineRun.java
 *  Class Name = axCmdLineRun
 *
 *  Copyright 1999-2004, Etasoft Inc.
 *  All rights are reserved. Reproduction in whole or part is prohibited
 *  without the written consent of the copyright owner.
 *
 *  @author tv.
 *  @date Tuesday, May 4, 2004
 */

import com.etasoft.trans.transaction.axInputParameters;
import com.etasoft.trans.transaction.axTransactionRunner;

/**
 * Command line runner for map execution via command line.
 */
public final class axCmdLineRun {
    
    private axCmdLineRun() {
                
    }
    
    private void run(String[] args) {
        
        System.out.println();
        System.out.println(" Cross Translator Command Line processing utility");
        System.out.println(" Copyright (C) 2004-2005 Etasoft Inc.");
        System.out.println("");
        System.out.println();
        
        // get map file name here
        if (args.length < 1) {
            System.out.println("Missing input parameters");
            System.out.println("[map_file_name] [parameter1=value1] [parameter2=value2]");
            System.out.println();
            System.out.println("First parameter is mandatory");
            System.out.println("Pass PRIORITY=MIN for workstation type processing");
            System.out.println();
            return;        
        }            
    
        try {
            String mapFileName = args[0];
            axInputParameters inputParameters = new axInputParameters();

            // HOW TO set license key manually
            // String args2[] = { "LICENSE=45AA-ATHF-YOUR_KEY" };      // set license key manually
            // inputParameters.addOver(args2, true);    // add the set license key

            // HOW TO use internal buffers instead of files for input and output:
            //   You can also pass buffers instead of files. It is useful in web applications.
            //   Use inputParameters methods setInputBuffer(char[] ) and setOutputBuffer(StringBuffer ) but if you do that
            //   you will also need to set DataPath properties for input to:
            //    stream://com.etasoft.trans.io.axCustomInputBuffer
            //    and output to:
            //    stream://com.etasoft.trans.io.axCustomOutputBuffer

            inputParameters.addOver(args, true);
            
            // run map
            axTransactionRunner runner = new axTransactionRunner(mapFileName, 
                inputParameters);
            runner.runMap();            

            System.out.println("COMPLETE");
        }
        catch (InterruptedException exp) {
            System.out.println("Translation interrupted.");
        }
        catch (Throwable exp2) {
            System.out.println("PROCESSING FAILED");
            System.out.println("Error: " + exp2.getMessage());
        }
    }
    
    public static void main(String[] args) {
        new axCmdLineRun().run(args);
    }

}

