/**
 *  File Name  = axCustomOutputBuffer2.java
 *  Class Name = axCustomOutputBuffer2
 *
 *  Copyright 1999-2004, Etasoft Inc.
 *  All rights are reserved. Reproduction in whole or part is prohibited
 *  without the written consent of the copyright owner.
 *
 *  @author tv.
 *  @date Tuesday, February 1, 2005
 */

package com.etasoft.trans.io;     

import com.etasoft.trans.exception.axException;
import com.etasoft.trans.transaction.axInputParameters;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;

/**
 * Custom output buffer.
 */
public class axCustomOutputBuffer2 extends axWriter {
    axCustomInputParameters m_inputParams = null; 

    /**     
     * Custom writer must have parameterless constructor in order to be instantiated.
     */ 
    public axCustomOutputBuffer2() throws axException {

    }

    /**
     * Open writer.
     */
    public void open(String filePath, axInputParameters inputParams) throws axException {
        try {
            // You can open any stream of your choice here. dataPath will contain name of this class
            // entered in DataPath property. Not very useful.
            //
            // It is recommended not to hardcode files names or connection strings here
            // but store them in external properties files or database configuration tables.
            // We did hardcode file name below just for simplicity.
            m_inputParams = (axCustomInputParameters) inputParams;
        }
        catch (Exception exp) {
            throw new axException(exp);
        }
    }
    
    /**
     * Close output writer.
     */
    public void close() throws axException {
        
    }
        
    /**
     * Write characters to the output.
     */
    public void write(char[] cbuf) throws axException {
        m_inputParams.appendData(cbuf); // append data in the internal buffer for the output
    }
    
    /**
     * Write section and related elements or fields.
     */
    public void write(String section, HashMap tabFields, boolean prepareSQL) throws axException {
        // not implemeted for this writer. It is used in Database mappings.
        assert (false);
    }

}


