/**
 *  File Name  = axCustomReader.java
 *  Class Name = axCustomReader
 *
 *  Copyright 1999-2005, Etasoft Inc.
 *  All rights are reserved. Reproduction in whole or part is prohibited
 *  without the written consent of the copyright owner.
 *
 *  @author tv.
 *  @date Tuesday, February 1, 2005
 */

package com.etasoft.trans.io;

import com.etasoft.trans.exception.axException;
import com.etasoft.trans.transaction.axInputParameters;
import java.util.ArrayList;
import java.io.Reader;
import java.io.FileReader;
import java.io.File;
import java.io.IOException;

/**
 * Custom reader.
 */
public class axCustomReader extends axReader {
    FileReader m_inputReader;

    /**     
     * Custom reader must have parameterless constructor in order to be instantiated.
     */
	public axCustomReader() throws axException {        

    }

    /**
     * Open reader.
     */
    public void open(String dataPath, axInputParameters inputParams) throws axException {
        try {
            // You can open any stream of your choice here. dataPath will contain name of this class
            // entered in DataPath property. Not very useful.
            //
            // It is recommended not to hardcode files names or connection strings here
            // but store them in external properties files or database configuration tables.
            // We did hardcode file name below just for simplicity.
            m_inputReader = new FileReader("C:\\test\\ctrans\\test.xml");
        }
        catch (Exception exp) {
            throw new axException(exp);
        }
    }
    
    /**
     * Get list of files matching wildcard criterion in dataPath.
     */
    public static ArrayList getList(String dataPath) {
        // This is service method used by translator. For example: if wildcard is used
        // in DataPath like this:
        // file://C:\test\myinput*.txt 
        // this method should return all files in directory matching this pattern.
        ArrayList arrDataPath = new ArrayList();
        arrDataPath.add(dataPath);

        // In our case we simply return same single dataPath we just received.
        return arrDataPath;
    }
    
    /**
     * Close reader.
     */
    public void close() throws axException {
        try {
            // Do not forget to close your opened streams here.
            m_inputReader.close();
        }
        catch (IOException exp) {
            throw new axException(exp);
        }
    }
    
    /**
     * Read number of characters.
     * Returns: The number of characters read, or -1 if the end of the stream has been reached.
     */
    public int read(char[] cbuf) throws axException {
        try {
            // This is where data is actually retrieved.
            return m_inputReader.read(cbuf);
        }
        catch (IOException exp) {
            throw new axException(exp);
        }
    }
    
}

