/**
 *  File Name  = axCustomWriter.java
 *  Class Name = axCustomWriter
 *
 *  Copyright 1999-2004, Etasoft Inc.
 *  All rights are reserved. Reproduction in whole or part is prohibited
 *  without the written consent of the copyright owner.
 *
 *  @author tv.
 *  @date Tuesday, February 1, 2005
 */

package com.etasoft.trans.io;

import com.etasoft.trans.exception.axException;
import com.etasoft.trans.transaction.axInputParameters;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;

/**
 * Custom Writer.
 */
public class axCustomWriter extends axWriter {
    FileWriter m_outputWriter;

    /**     
     * Custom writer must have parameterless constructor in order to be instantiated.
     */ 
    public axCustomWriter() throws axException {

    }

    /**
     * Open writer.
     */
    public void open(String filePath, axInputParameters inputParams) throws axException {
        try {
            // You can open any stream of your choice here. dataPath will contain name of this class
            // entered in DataPath property. Not very useful.
            //
            // It is recommended not to hardcode files names or connection strings here
            // but store them in external properties files or database configuration tables.
            // We did hardcode file name below just for simplicity.
            m_outputWriter = new FileWriter("C:\\test\\myoutput.txt");
        }
        catch (Exception exp) {
            throw new axException(exp);
        }
    }
    
    /**
     * Close output writer.
     */
    public void close() throws axException {
        try {
            // Do not forget to close your opened streams here.
            m_outputWriter.close();
        }
        catch (IOException exp) {
            throw new axException(exp);
        }
    }
        
    /**
     * Write characters to the output.
     */
    public void write(char[] cbuf) throws axException {
        try {
            // Write characters to the output.
            m_outputWriter.write(cbuf);
        }
        catch (IOException exp) {
            throw new axException(exp);
        }
    }
    
    /**
     * Write section and related elements or fields.
     */
    public void write(String section, HashMap tabFields, boolean prepareSQL) throws axException {
        // not implemeted for this writer. It is used in Database mappings.
        assert (false);
    }

}

